PingAuthorize API Reference

Update Parent Policies of Rule (ID)

PUT {{apiPath}}/v2/policy-manager/rules/{{ruleId}}/parents?branch={{branchId}}

The PUT /v2/policy-manager/rules/{{ruleId}}/parents operation updates the set of parent policies for the rule specified by the ID in the request URL. The request must provide either a branch ID or a snapshot ID in the request URL.

Prerequisites

Query parameters
Query parameter Description

branch

Branch ID or name

snapshot

Snapshot ID

page

Page number of returned policies

page-size

Number of policies per page

Headers

Content-Type      application/json

x-user-id      {{userId}}

Body

raw ( application/json )

[
  {
    "id": {{policyId}},
    "type": "Policy"
  },
  {
    "id": {{anotherPolicyId}},
    "type": "Policy"
  }
]

Example Request

  • cURL

  • C#

  • Go

  • HTTP

  • Java

  • jQuery

  • NodeJS

  • Python

  • PHP

  • Ruby

  • Swift

curl --location --globoff --request PUT '{{apiPath}}/v2/policy-manager/rules/{{ruleId}}/parents?branch={{branchId}}' \
--header 'x-user-id: {{userId}}' \
--header 'Content-Type: application/json' \
--data '[
  {
    "id": {{policyId}},
    "type": "Policy"
  },
  {
    "id": {{anotherPolicyId}},
    "type": "Policy"
  }
]'
var options = new RestClientOptions("{{apiPath}}/v2/policy-manager/rules/{{ruleId}}/parents?branch={{branchId}}")
{
  MaxTimeout = -1,
};
var client = new RestClient(options);
var request = new RestRequest("", Method.Put);
request.AddHeader("x-user-id", "{{userId}}");
request.AddHeader("Content-Type", "application/json");
var body = @"[" + "\n" +
@"  {" + "\n" +
@"    ""id"": {{policyId}}," + "\n" +
@"    ""type"": ""Policy""" + "\n" +
@"  }," + "\n" +
@"  {" + "\n" +
@"    ""id"": {{anotherPolicyId}}," + "\n" +
@"    ""type"": ""Policy""" + "\n" +
@"  }" + "\n" +
@"]";
request.AddStringBody(body, DataFormat.Json);
RestResponse response = await client.ExecuteAsync(request);
Console.WriteLine(response.Content);
package main

import (
  "fmt"
  "strings"
  "net/http"
  "io"
)

func main() {

  url := "{{apiPath}}/v2/policy-manager/rules/{{ruleId}}/parents?branch={{branchId}}"
  method := "PUT"

  payload := strings.NewReader(`[
  {
    "id": {{policyId}},
    "type": "Policy"
  },
  {
    "id": {{anotherPolicyId}},
    "type": "Policy"
  }
]`)

  client := &http.Client {
  }
  req, err := http.NewRequest(method, url, payload)

  if err != nil {
    fmt.Println(err)
    return
  }
  req.Header.Add("x-user-id", "{{userId}}")
  req.Header.Add("Content-Type", "application/json")

  res, err := client.Do(req)
  if err != nil {
    fmt.Println(err)
    return
  }
  defer res.Body.Close()

  body, err := io.ReadAll(res.Body)
  if err != nil {
    fmt.Println(err)
    return
  }
  fmt.Println(string(body))
}
PUT /v2/policy-manager/rules/{{ruleId}}/parents?branch={{branchId}} HTTP/1.1
Host: {{apiPath}}
x-user-id: {{userId}}
Content-Type: application/json

[
  {
    "id": {{policyId}},
    "type": "Policy"
  },
  {
    "id": {{anotherPolicyId}},
    "type": "Policy"
  }
]
OkHttpClient client = new OkHttpClient().newBuilder()
  .build();
MediaType mediaType = MediaType.parse("application/json");
RequestBody body = RequestBody.create(mediaType, "[\n  {\n    \"id\": {{policyId}},\n    \"type\": \"Policy\"\n  },\n  {\n    \"id\": {{anotherPolicyId}},\n    \"type\": \"Policy\"\n  }\n]");
Request request = new Request.Builder()
  .url("{{apiPath}}/v2/policy-manager/rules/{{ruleId}}/parents?branch={{branchId}}")
  .method("PUT", body)
  .addHeader("x-user-id", "{{userId}}")
  .addHeader("Content-Type", "application/json")
  .build();
Response response = client.newCall(request).execute();
var settings = {
  "url": "{{apiPath}}/v2/policy-manager/rules/{{ruleId}}/parents?branch={{branchId}}",
  "method": "PUT",
  "timeout": 0,
  "headers": {
    "x-user-id": "{{userId}}",
    "Content-Type": "application/json"
  },
  "data": "[\n  {\n    \"id\": {{policyId}},\n    \"type\": \"Policy\"\n  },\n  {\n    \"id\": {{anotherPolicyId}},\n    \"type\": \"Policy\"\n  }\n]",
};

$.ajax(settings).done(function (response) {
  console.log(response);
});
var request = require('request');
var options = {
  'method': 'PUT',
  'url': '{{apiPath}}/v2/policy-manager/rules/{{ruleId}}/parents?branch={{branchId}}',
  'headers': {
    'x-user-id': '{{userId}}',
    'Content-Type': 'application/json'
  },
  body: '[\n  {\n    "id": {{policyId}},\n    "type": "Policy"\n  },\n  {\n    "id": {{anotherPolicyId}},\n    "type": "Policy"\n  }\n]'

};
request(options, function (error, response) {
  if (error) throw new Error(error);
  console.log(response.body);
});
import requests
import json

url = "{{apiPath}}/v2/policy-manager/rules/{{ruleId}}/parents?branch={{branchId}}"

payload = "[\n  {\n    \"id\": {{policyId}},\n    \"type\": \"Policy\"\n  },\n  {\n    \"id\": {{anotherPolicyId}},\n    \"type\": \"Policy\"\n  }\n]"
headers = {
  'x-user-id': '{{userId}}',
  'Content-Type': 'application/json'
}

response = requests.request("PUT", url, headers=headers, data=payload)

print(response.text)
<?php
require_once 'HTTP/Request2.php';
$request = new HTTP_Request2();
$request->setUrl('{{apiPath}}/v2/policy-manager/rules/{{ruleId}}/parents?branch={{branchId}}');
$request->setMethod(HTTP_Request2::METHOD_PUT);
$request->setConfig(array(
  'follow_redirects' => TRUE
));
$request->setHeader(array(
  'x-user-id' => '{{userId}}',
  'Content-Type' => 'application/json'
));
$request->setBody('[\n  {\n    "id": {{policyId}},\n    "type": "Policy"\n  },\n  {\n    "id": {{anotherPolicyId}},\n    "type": "Policy"\n  }\n]');
try {
  $response = $request->send();
  if ($response->getStatus() == 200) {
    echo $response->getBody();
  }
  else {
    echo 'Unexpected HTTP status: ' . $response->getStatus() . ' ' .
    $response->getReasonPhrase();
  }
}
catch(HTTP_Request2_Exception $e) {
  echo 'Error: ' . $e->getMessage();
}
require "uri"
require "json"
require "net/http"

url = URI("{{apiPath}}/v2/policy-manager/rules/{{ruleId}}/parents?branch={{branchId}}")

http = Net::HTTP.new(url.host, url.port);
request = Net::HTTP::Put.new(url)
request["x-user-id"] = "{{userId}}"
request["Content-Type"] = "application/json"
request.body = "[\n  {\n    \"id\": {{policyId}},\n    \"type\": \"Policy\"\n  },\n  {\n    \"id\": {{anotherPolicyId}},\n    \"type\": \"Policy\"\n  }\n]"

response = http.request(request)
puts response.read_body
let parameters = "[\n  {\n    \"id\": {{policyId}},\n    \"type\": \"Policy\"\n  },\n  {\n    \"id\": {{anotherPolicyId}},\n    \"type\": \"Policy\"\n  }\n]"
let postData = parameters.data(using: .utf8)

var request = URLRequest(url: URL(string: "{{apiPath}}/v2/policy-manager/rules/{{ruleId}}/parents?branch={{branchId}}")!,timeoutInterval: Double.infinity)
request.addValue("{{userId}}", forHTTPHeaderField: "x-user-id")
request.addValue("application/json", forHTTPHeaderField: "Content-Type")

request.httpMethod = "PUT"
request.httpBody = postData

let task = URLSession.shared.dataTask(with: request) { data, response, error in
  guard let data = data else {
    print(String(describing: error))
    return
  }
  print(String(data: data, encoding: .utf8)!)
}

task.resume()

Example Response

200 OK

{
    "pagination": {
        "page": 1,
        "pageSize": 100,
        "totalItems": 2,
        "totalPages": 1
    },
    "data": [
        {
            "id": "69d82f74-5561-4f91-b238-0f8bbac97532",
            "type": "Policy"
        },
        {
            "id": "62d82174-5561-4f91-b138-0f5bbac97532",
            "type": "Policy"
        }
    ]
}